

AutoItSetOption ("WinTitleMatchMode", 2) ; 2 = match any string in window title

Global $original

#cs

WFTMserver_extract.au3
v0.1, Samuel Murray, 27 Dec 2014
v0.2, 8 Sep 2017 - uses Go to Segment to go to next segment, does not extract current text

This script interacts with WFP to extract segments from an online TM that matches the segments in the current TXML file.  You can't do anything else on the computer while the script is running.

How to prepare WFP for the script's actions:

1. Load the online TM as an active but read-only TM.
2. Set WFP to not complain if there is no active TM.
3. Make the TM Lookup pane quite large (so that no segment match will ever be longer than the pane is tall).

#ce

$askifreadinstructions = MsgBox (260, "Have you read the instructions?", "Have you read the instructions?  Is WFP ready for you?", 0)
If $askifreadinstructions = 7 Then
Exit
EndIf

$windowbar = InputBox ("What is the WFP's window's title?", "What are some unique words that appear in WFP's window bar?  Accept default if uncertain.", "- Wordfast Pro")

; $startnumsegs = InputBox ("Start at which segment?", "Start at which segment?", "1")
; $endnumsegs = InputBox ("End at which segment?", "End at which segment?", "10")

#cs
MsgBox (0, "Mouse over TITLE BAR", "Hover your mouse over WFP's DOCUMENT TITLE BAR (not the main window bar, but the document's own title bar).  Hover for 5 seconds.", 5)
Sleep ("1000") ; so actually you have 6 seconds
$titlebarpos = MouseGetPos ()
#ce

MsgBox (0, "Mouse over SOURCE FIELD", "Hover your mouse over the first row of the ""TM Lookup"" source text field.  Hover for 5 seconds.", 5)
Sleep ("1000") ; so actually you have 6 seconds
$sourcefieldpos = MouseGetPos ()

MsgBox (0, "Mouse over TARGET FIELD", "Hover your mouse over the first row of the ""TM Lookup"" target text field.  Hover for 5 seconds.", 5)
Sleep ("1000") ; so actually you have 6 seconds
$targetfieldpos = MouseGetPos ()

MsgBox (0, "Mouse over DOWN SCROLL BUTTON", "Hover your mouse over the downward arrow in the scroll bar of the ""TM Lookup"" pane.  Hover for 5 seconds.", 5)
Sleep ("1000") ; so actually you have 6 seconds
$downbuttonpos = MouseGetPos ()

$numsegsextract = InputBox ("How many fuzzy matches per segment to extract?", "How many fuzzy matches should the script attempt to extract for each segment?  99 = all, 0 = none, 1 = one, 2 = two, etc.  Less is faster, more is comprehensiver.", "99")

$filesavedialog = FileSaveDialog ("File to save segments in", @ScriptDir, "Text files (*.txt)|All (*.*)", 16, "serverTMoutput.txt") ; 16 = prompt to overwrite
$fileopendialog = FileOpen ($filesavedialog, 33)
; 32 = UTF16LE + 1 = append to old file, if any


HotKeySet ("`", "_extractit")

While 1
Sleep ("100")
WEnd


Func _extractit ()

WinActivate ($windowbar, "") ; checks if WFP still has focus

$b_old = "asdfjklsemicolon" ; a temporary value that hopefully never occurs in the file

$y = $numsegsextract

$original = MouseGetPos ()

; MsgBox (0, "", "asdf", 0)

While $y > 0

MouseClick ("left", $targetfieldpos[0], $targetfieldpos[1], 1, 0)
Sleep ("10")
MouseClick ("left", $sourcefieldpos[0], $sourcefieldpos[1], 1, 0)
Sleep ("100")

_sleepSend ("^a")
_sleepSend ("^c")
$b = ClipGet ()
Sleep ("200")

$comparetwo = StringCompare ($b, $b_old, 1)
If $comparetwo = 0 Then ; if they're the same
ExitLoop ; exit the while loop
EndIf

MouseClick ("left", $targetfieldpos[0], $targetfieldpos[1], 1, 0)
Sleep ("10")
MouseClick ("left", $targetfieldpos[0], $targetfieldpos[1], 1, 0)
Sleep ("100")

_sleepSend ("^a")
_sleepSend ("^c")
$c = ClipGet ()
Sleep ("200")

$comparetwo = StringCompare ($c, $b, 1)
If $comparetwo = 0 Then ; if they're the same
ExitLoop ; exit the while loop
EndIf

FileWrite ($fileopendialog, $b & @TAB)
$b_old = $b

FileWrite ($fileopendialog, $c & @CRLF)

; _sleepSend ("{TAB}")
MouseClick ("left", $downbuttonpos[0], $downbuttonpos[1], 1, 0)

$y = $y - 1

WEnd

MouseClick ("left", $original[0], $original[1], 1, 0)

EndFunc


Func _sleepSend ($sendvar)
Send ($sendvar)
Sleep ("100")
EndFunc

