

AutoItSetOption ("WinTitleMatchMode", 2) ; 2 = match any string in window title

#cs

WFTMserver_extract.au3
v0.1, Samuel Murray, 27 Dec 2014

This script interacts with WFP to extract segments from an online TM that matches the segments in the current TXML file.  You can't do anything else on the computer while the script is running.

How to prepare WFP for the script's actions:

1. Load the online TM as an active but read-only TM.
2. Set WFP to not complain if there is no active TM.
3. Make the TM Lookup pane quite large (so that no segment match will ever be longer than the pane is tall).
4. If the TXML file is fully empty, let WFP copy source when no match. (WE CURRENTLY ASSUME THAT IT IS... BUT LATER feature: if TXML file is partially translated, deal with it).

#ce

$askifreadinstructions = MsgBox (260, "Have you read the instructions?", "Have you read the instructions?  Is WFP ready for you?", 0)
If $askifreadinstructions = 7 Then
Exit
EndIf

$windowbar = InputBox ("What is the WFP's window's title?", "What are some unique words that appear in WFP's window bar?  Accept default if uncertain.", "- Wordfast Pro")

$numsegs = InputBox ("How many segments?", "How many segments?", "10")

MsgBox (0, "Mouse over TITLE BAR", "Hover your mouse over WFP's DOCUMENT TITLE BAR (not the main window bar, but the document's own title bar).  Hover for 5 seconds.", 5)
Sleep ("1000") ; so actually you have 6 seconds
$titlebarpos = MouseGetPos ()

MsgBox (0, "Mouse over SOURCE FIELD", "Hover your mouse over the first row of the ""TM Lookup"" source text field.  Hover for 5 seconds.", 5)
Sleep ("1000") ; so actually you have 6 seconds
$sourcefieldpos = MouseGetPos ()

MsgBox (0, "Mouse over TARGET FIELD", "Hover your mouse over the first row of the ""TM Lookup"" target text field.  Hover for 5 seconds.", 5)
Sleep ("1000") ; so actually you have 6 seconds
$targetfieldpos = MouseGetPos ()

MsgBox (0, "Mouse over DOWN SCROLL BUTTON", "Hover your mouse over the downward arrow in the scroll bar of the ""TM Lookup"" pane.  Hover for 5 seconds.", 5)
Sleep ("1000") ; so actually you have 6 seconds
$downbuttonpos = MouseGetPos ()

$askifactivesource = MsgBox (260, "Capture current text also?", "Should the script also capture the active segment's source text?", 0)
; 4 = yes/no button + 256 = second button is default
; if $askifactivesource = 6 then answer is "yes"

$numsegsextract = InputBox ("How many fuzzy matches per segment to extract?", "How many fuzzy matches should the script attempt to extract for each segment?  99 = all, 0 = none, 1 = one, 2 = two, etc.  Less is faster, more is comprehensiver.", "99")

$filesavedialog = FileSaveDialog ("File to save segments in", @ScriptDir, "Text files (*.txt)|All (*.*)", 16, "serverTMoutput.txt") ; 16 = prompt to overwrite
$fileopendialog = FileOpen ($filesavedialog, 33)
; 32 = UTF16LE + 1 = append to old file, if any

MsgBox (0, "Click in first segment", "Click in first segment, you have 5 seconds", 5)

Sleep ("5000") ; so actually you have 10 seconds

$savecounter = 0

For $i = 1 to $numsegs

$savecounter = $savecounter + 1

WinActivate ($windowbar, "") ; checks if WFP still has focus

_sleepSend ("!{DOWN}") ; ! = alt
_sleepSend ("^a")
_sleepSend ("^c")
$checkifmatch1 = ClipGet ()
Sleep ("200")
_sleepSend ("!{INSERT}")
_sleepSend ("^a")
_sleepSend ("^c")
$checkifmatch2 = ClipGet ()
Sleep ("200")
; _sleepSend ("^z") ; for future version, when it would matter

$compareone = StringCompare ($checkifmatch1, $checkifmatch2, 1) ; 1 = case sensitive
If $compareone = 0 Then ; if they're the same, then there's no fuzzy match
ContinueLoop ; go to next iteration of For loop
EndIf

If $askifactivesource = 6 Then
$a = $checkifmatch2
EndIf

$b_old = "asdfjklsemicolon" ; a temporary value that hopefully never occurs in the file

$y = $numsegsextract

While $y > 0

MouseClick ("left", $sourcefieldpos[0], $sourcefieldpos[1], 1, 0)

_sleepSend ("^a")
_sleepSend ("^c")
$b = ClipGet ()
Sleep ("200")

$comparetwo = StringCompare ($b, $b_old, 1)
If $comparetwo = 0 Then ; if they're the same
ExitLoop ; exit the while loop
EndIf

If $askifactivesource = 6 Then
FileWrite ($fileopendialog, $a & @TAB)
EndIf

FileWrite ($fileopendialog, $b & @TAB)
$b_old = $b

MouseClick ("left", $targetfieldpos[0], $targetfieldpos[1], 1, 0)

_sleepSend ("^a")
_sleepSend ("^c")
$c = ClipGet ()
Sleep ("200")

FileWrite ($fileopendialog, $c & @CRLF)

; _sleepSend ("{TAB}")
MouseClick ("left", $downbuttonpos[0], $downbuttonpos[1], 1, 0)

$y = $y - 1

WEnd

MouseClick ("left", $titlebarpos[0], $titlebarpos[1], 1, 0)

If $savecounter > 20 Then
$savecounter = 0
_sleepSend ("^s")
Sleep ("3000") ; i.e. hope that WFP takes less than 3 seconds to save the file
EndIf

Next

Func _sleepSend ($sendvar)
Send ($sendvar)
Sleep ("200")
EndFunc

